from point import Point

# parent class of all lattices
class Lattice():
    def __init__(self,**kwargs):
        self.type=kwargs.get("type","")

    # lattice point nearest to point
    # overwrite in subclasses
    def nearest(self,point):
        return point

    # delta to nearest point
    def nearest_delta(self,point):
        return self.nearest(point)-point

    # draw lattice
    # overwrite in subclasses
    def draw(self,painter):
        return


# square lattice
class Square_lattice(Lattice):
    def __init__(self,**kwargs):

        self.spacing=kwargs.get("spacing",1.)

        super(Square_lattice,self).__init__(**kwargs,type="square")

    # lattice point nearest to point
    def nearest(self,point):
        return Point(round(point.x/self.spacing)*self.spacing,round(point.y/self.spacing)*self.spacing)

    # draw
    def draw(self,painter):
        painter.draw_grid(Point(self.spacing/2,self.spacing/2),self.spacing)
        
